config/routes.rb
Rails.application.routes.draw do
	devise_for :users, :controllers => { :omniauth_callbacks => "callbacks" } , path: "auth"

	resources :albums, except: [:index]
	resources :photos , except: [:index]
	resources :users, only: [:show]
 	authenticated :users do
 		root 'users#show'
	end
	unauthenticated :users do
	    root 'photos#discover_photos'
	end

	namespace :admin do
      	resources :albums, except: [:new, :create]
      	resources :users, except: [:new, :create]
      	resources :photos, except: [:new, :create]
      	delete '/delete/images' => 'albums#delete_images', as: :delete_images
		delete '/album/:album_id/delete/:image_id/images_old/' => 'albums#delete_image_attachment', as: :delete_images_old
    end

	get '/feed/photos' => 'photos#feed_photos'
	get '/feed/albums' => 'albums#feed_albums'

	get '/discover/photos' => 'photos#discover_photos'
	get '/discover/albums' => 'albums#discover_albums'

	delete '/delete/images' => 'albums#delete_images', as: :delete_images
	delete '/album/:album_id/delete/:image_id/images_old/' => 'albums#delete_image_attachment', as: :delete_images_old
	
	post '/user/:id/follow_user', to: 'relations#follow_user', as: :follow_user
  	post '/user/:id/unfollow_user', to: 'relations#unfollow_user', as: :unfollow_user

  	post '/:likeable_id/:likeable_type/like', to: 'likes#like', as: :like
  	post '/:likeable_id/:likeable_type/unlike', to: 'likes#unlike', as: :unlike
end

app/models/photo.rb
class Photo < ApplicationRecord
	belongs_to :user
	has_many :likes, as: :likeable, dependent: :destroy
	has_one_attached :image

	#Create scope
	scope :new_first, -> { order(created_at: :desc)}

	#Validation
	validates :title, :description,  presence: true
	validates_associated :likes
	validates :title,    length: { in: 1..140 }
	validates :description,    length: { in: 1..300 }
end

app/controllers/admin/photos_controller.rb
class Admin::PhotosController < ApplicationController
	before_action :authenticate_user!
	before_action :set_photo, only: [:index, :edit, :update, :destroy]

	def index
 		@photo = Photo.all.new_first.page(params[:page]).per(8)
 	end

	def edit
	end

	def update
		if params[:photo][:image] != nil
			@photo_admin.update(title: params[:photo][:title], private: params[:photo][:private], image: params[:photo][:image],description: params[:photo][:description])
			flash[:notice] = "Photo edited successfully!"
			@photo = Photo.all.new_first.page(params[:page]).per(8)
			render "index"
		elsif params[:photo][:images] == nil && @photo_admin.title == params[:photo][:title]  && @photo_admin.description == params[:photo][:description]  && @photo_admin.private.to_s == params[:photo][:private]
			@photo_admin.update(title: params[:photo][:title], private: params[:photo][:private], description: params[:photo][:description])
			flash[:notice] = "Unchanged through time"
			@photo = Photo.all.new_first.page(params[:page]).per(8)
			render "index"
		else 
			@photo_admin.update(title: params[:photo][:title], private: params[:photo][:private], description: params[:photo][:description])
			flash[:alert] = "#{@photo.errors.full_messages.join(', ')}"
			redirect_to edit_admin_photo_path(@photo_admin)
		end
	end

	def destroy
		@photo_admin.destroy
		@photo = Photo.all.new_first.page(params[:page]).per(8)
		flash[:notice] = "Photo delete successfully!"
		render "index"
	end

	private

	def set_photo
	    @photo_admin = Photo.find_by(id: params[:id])
	end

	def photo_params
		params.require(:photo).permit( :title, :private, :image, :description )
	end
end

app/controllers/photos_controller.rb
class PhotosController < ApplicationController
	before_action :authenticate_user!
	before_action :set_photo, only: [:show, :edit, :update, :destroy]
	def feed_photos
		list_follow = current_user.following.ids
		@photo_manage = Photo.new_first.where(private: false, user_id: list_follow).page(params[:page]).per(6)
	end

	def discover_photos
		@photo_manage = Photo.new_first.where(private: false).page(params[:page]).per(6)
	end

	def show
    	@photo = Photo.find(params[:id])
 	end

	def new
	   	@photo = Photo.new
	end

	def create
	    @photo = current_user.photos.new(photo_params)
	   	if @photo.save && @photo.image.attached?
	    	flash[:notice] = "Photo created successfully!"
	    	redirect_to current_user
	  	elsif
	  		if @photo.image.attached? == false
				flash[:alert] = "Please choose your image"
				render "new"
	  		else
	    		flash[:alert] = "#{@photo.errors.full_messages.join(', ')}"
	    		render  "new"
	    	end
	 	end
	end

	def edit
	end

	def update
		if params[:photo][:private] != @photo.private.to_s || params[:photo][:title] != @photo.title || params[:photo][:description] != @photo.description
			if params[:photo][:image] != nil
				@photo.update(title: params[:photo][:title], private: params[:photo][:private], image: params[:photo][:image],description: params[:photo][:description])
			else 	
				@photo.update(title: params[:photo][:title], private: params[:photo][:private], description: params[:photo][:description])
			end
			flash[:notice] = "Photo edited successfully!"
			redirect_to current_user
		elsif params[:photo][:images] == nil && @photo.title == params[:photo][:title]  && @photo.description == params[:photo][:description]  && @photo.private.to_s == params[:photo][:private]
			@photo.update(title: params[:photo][:title], private: params[:photo][:private], description: params[:photo][:description])
			flash[:notice] = "Unchanged through time"
			redirect_to current_user
		else 
			flash[:alert] = "#{@photo.errors.full_messages.join(', ')}"
			redirect_to edit_photo_path(@photo)
		end
	end

	def destroy
		@photo.destroy
		flash[:notice] = "Photo delete successfully!"
		redirect_to current_user
	end

	private

	def set_photo
	    @photo = Photo.find_by(id: params[:id])
	end

	def photo_params
		params.require(:photo).permit( :title, :private, :image, :description )
	end
 
end

app/views/photos/_list_photos.html.erb
<div class="container-body">
	<div class="row">
		<% if photos != nil %>
			<% photos.each do |pts| %>
				<div class=" col-sm-12 col-lg-6  ">
					<div class="list_album">
						<a data-toggle="modal" href="#<%=pts.id%>">
							<div class="col-sm-6 col-lg-6 album">
									<%= image_tag(pts.image, class: "photo item small")%>
							</div>
						</a>
						<!-- Create The modal -->
						<div class="modal fade" id= "<%=pts.id%>" tabindex="-1" role="dialog" aria-labelledby="modalLabel" aria-hidden="true">
						    <div class="modal-dialog modal-sm" role="document">
						      	<div class="modal-content">
						        	<div class="modal-header">
						          		<h4 class="modal-title" id="modalLabel"><%= pts.title %></h4>
						          		<button type="button" class="close" data-dismiss="modal" aria-label="Close">
						           		 	<span aria-hidden="true">&times;</span>
						         	 	</button>
						        	</div>
							        <div class="modal-body">
 										<!-- Wrapper for slides -->
									 	 <%= image_tag(pts.image, class: "photo") %>
							        </div>
							        <div class="modal-footer">
							        	<h3><%= pts.description %></h3> 
							        </div>
						      	</div>
						    </div>
						</div>
						<!-- End The modal -->
						<div class="col-sm-offset-6 col-lg-offset-6 ">
							<div class="col-sm-3 col-lg-3">
								<%= image_tag(pts.user.avatar, class: "avatar photo img-circle") %>
							</div>
							<div class="col-sm-offset-4 col-lg-offset-4 name-user">
								<%= link_to pts.user.full_name, user_path(id: pts.user_id) %>
							</div>
							<form class="col-lg-offset-6 col-sm-offset-6 " >
								<% if current_user.id != pts.user_id %>
									<% if current_user.following.ids.include? pts.user_id %>
					                	<%= link_to "Following", unfollow_user_path(id: pts.user_id),  class: 'btn follow-button', id: 'unfollow-button', method: :post %>
						            <%else%>
						                <%= link_to "Follow", follow_user_path(id: pts.user_id),  class: 'btn follow-button', id: 'follow-button', method: :post %>
				           			<%end%>
								<%end%>
							</form>
							<div class="title">
								<% if pts.title.size > 20 %>
				                  	<%= pts.title[0..20] + "... " %> 
				                <%else%>
				                 	 <%= pts.title %> 
				                <%end%> 
							</div>
							<div class="description">
								<% if pts.description.size > 100 %>
				                	  <%= pts.description[0..100] + "... " %> 
				                <%else%>
				                 	 <%= pts.description %> 
				                <%end%>
							</div>
						</div>
						<div class="col-sm-offset-6 col-lg-offset-6 publication">
							<div class="col-sm-4 col-lg-4 time-post-album">
								<% if  Like.where(likeable_type: "Photo", likeable_id: pts.id).pluck(:user_id).include? current_user.id %>
									<%= link_to '<i class="fa fa-heart" style="font-size:36px;" id="like"></i>'.html_safe, unlike_path(likeable_type: "Photo", likeable_id: pts.id), method: :post, id: "like-link"%>
								<%else%>
									<%= link_to '<i class="fa fa-heart" style="font-size:36px;" id="unlike"></i>'.html_safe, like_path(likeable_type: "Photo", likeable_id: pts.id), method: :post, id: "unlike-link" %>
								<%end%>							
								<%= pts.likes.size%>
							</div>
							<div class="col-sm-8 col-lg-8 time-post-album">
								<p><%=l pts.updated_at, format: :default%></p>
							</div>
						</div>	
					</div>
				</div>
			<%end%>
			
			<div class="row col-lg-12 col-sm-12">
				<%= paginate @photo_manage %>
			</div>
		<%end%>
	</div>
</div>

app/views/photos/_show_photo.html.erb
<div class="container-body">
  <% if current_user.id == @user.id %>
      <div class="row">
          <div class="col-sm-3 col-sm-offset-8 col-lg-2 col-lg-offset-9">
            <%= link_to '+ ADD PHOTOS', new_photo_path, class: "btn btn-lg btn-success" %> 
          </div> 
      </div>
  <%end%>
  <div class="row col-lg-12">
    <% if photo != nil%>
      <% photo.each do |pts| %>
        <% if pts.image.attached?%>
          <div class="col-sm-6 col-lg-3 title-photo photo-show">
            <div class="col-lg-12 photo-single">
              <% if current_user.id == @user.id && pts.private == true %>
                <div class="lock-photo col-sm-offset-8 col-lg-offset-10 ">
                  <i class="fa fa-lock" style="font-size: 30px;" id = "lock-icon"></i>
                </div>
              <%end%>
              <div class="edit-photo btn">
                <%= link_to "EDIT", edit_photo_path(id: pts.id) %>
              </div>
                <a data-toggle="modal" href="#<%=pts.id%>"><%= image_tag(pts.image, class: "photo medium") %></a>
              <div class="title-photo">
                <% if pts.title.size > 20 %>
                  <%= pts.title[0..20] + "... " %> 
                <%else%>
                  <%= pts.title %> 
                <%end%>   
              </div>
              <!-- Create The modal -->
              <div class="modal fade" id= "<%=pts.id%>" tabindex="-1" role="dialog" aria-labelledby="modalLabel" aria-hidden="true">
                <div class="modal-dialog modal-sm" role="document">
                    <div class="modal-content">
                      <div class="modal-header">
                          <h4 class="modal-title" id="modalLabel"><%= pts.title %></h4>
                          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                      </div>
                      <div class="modal-body ">
                        <%= image_tag(pts.image, class: "photo") %>
                      </div>
                      <div class="modal-footer">
                       <h2><%= pts.description %> </h2> 
                      </div>
                    </div>
                </div>
              </div>
              <!-- End The modal -->
            </div>
          </div>
        <%end%>
      <%end%>
    <%end%>
  </div>
  <div class="row col-lg-12 ">
    <%= paginate photo %>
  </div>
</div>

app/views/photos/discover_photos.html.erb
<%= render 'share/option_status' %>
<div class="row">
     <div class=" col-sm-offset-4 col-lg-offset-5 show-header">
        <%= link_to 'PHOTO', discover_photos_path, class: "btn btn-lg btn-option btn-option-click" %> 
        <%= link_to 'ALBUM', discover_albums_path, class: "btn btn-lg btn-option"%> 
    </div>
</div>
<!--Start container -->
<%= render 'list_photos', photos: @photo_manage %>
<!--End container-->

app/views/photos/edit.html.erb
<%= render 'share/option_status' %>
<div class="container-body col-lg-10 col-lg-offset-1">
  	<div class="title-page col-lg-12">
  		<div class="row col-lg-6">
  			<p> Edit Photo</p>
  		</div>
    	<div class="col-lg-offset-11 ">
			<%= link_to '<button class="btn btn-lg btn-primary white-btn">Back</button>'.html_safe, user_path(id: current_user.id) %>
    	</div>
  	</div>
	<div class="row">
	    <div class="col-lg-12">  
	    	<%= form_for(@photo, url: photo_path(@photo), html: { method: :put }) do |f| %>
	      		<div class="row album_wall">
		        <% if notice && notice != "Signed in successfully." %><div class="alert alert-info"><%= notice %></div><% end %>
		        <% if alert %><div class="alert alert-danger"><%= alert %></div><% end %>
		        <div class="row col-lg-12">
		          	<div class="col-lg-6">
			            <div class="form-group">
			              	<%= f.label :title %>
			              	<%= f.text_field :title, autofocus: true, class: 'form-control', require: true %>
			            </div>
			        </div>
			        <div class="col-lg-6">
			            <div class="form-group">
			             	<%= f.label :description %>
			             	<%= f.text_field :description, class: 'form-control', require: true %>
			            </div>
			        </div>
		        </div>
		        <div class="row col-lg-12">
			          <div class="form-group col-lg-6 ">
			            <%= f.label "Sharing mode" %>
			            <% if @photo.private == true%>
							<%= f.select(:private, options_for_select([['Private', true], ['Public', false]] ), {}, {:class => 'form-control'})  %>
			            <% else %>
							<%= f.select(:private, options_for_select([['Public', false], ['Private', true]] ), {}, {:class => 'form-control'})  %>
			            <% end %>   
		        	</div>
		        </div>
		        <div class=" form-group col-lg-4 ">
			        <div id="image-upload" >
			        	<i class="fa fa-window-close fa-2x close-icon" aria-hidden="true" id = "close-icon"></i>
			            <label for="file-input" class="label-upload" id="old-image">
			              	<%= image_tag(@photo.image, class: "photo medium") %>
			            </label>
			            <label for="file-input" class="label-upload" id= "new-image">
			              	<%= image_tag(@photo.image, class: "photo medium", id:"output") %>
			            </label>
			            <label for="file-input" class="label-upload" id = "upload-photo"  >
			              	<i class="fa fa-plus" style="font-size:70px; color: #BDBDBD;" id = "plus-icon"></i>
			            </label>
			            <%= f.file_field :image, multiple: false, id: "file-input", onchange: "document.getElementById('output').src = window.URL.createObjectURL(this.files[0])", class: "form-group upload-img"%><br> 
			        </div> 
		        </div>
		        <div class="row col-lg-12">
		        	<%= f.submit 'Save', class: 'btn btn-success btn-lg search ' %>
		        	<%= link_to '<i class="fa fa-trash" aria-hidden="true">Delete</i>'.html_safe, photo_path(id: @photo.id), method: :DELETE, class: "white-btn btn btn-lg btn-danger col-lg-offset-2 "%>
		        </div>
		    <% end %>
		</div>
	</div>
</div>

app/views/photos/feed_photos.html.erb
<%= render 'share/option_status' %>
<div class="row">
     <div class=" col-sm-offset-4 col-lg-offset-5 show-header">
        <%= link_to 'PHOTO', feed_photos_path, class: "btn btn-lg btn-option btn-option-click" %> 
        <%= link_to 'ALBUM', feed_albums_path, class: "btn btn-lg btn-option"%> 
    </div>
</div>
<!--Start container -->
<%= render 'list_photos', photos: @photo_manage  %>
<!--End container-->

app/views/photos/new.html.erb
<%= render 'share/option_status' %>
<div class="container-body col-lg-10 col-lg-offset-1">
  <div class="title-page col-lg-12">
    <div class="row col-lg-6 col-sm-6">
      <p> New Photo</p>
    </div>
    <div class="col-lg-offset-11 col-sm-offset-10">
      <%= link_to '<button class="btn btn-lg btn-primary white-btn">Back</button>'.html_safe, user_path(id: current_user.id) %>
    </div>
  </div>
  <div class="row">
    <div class="col-lg-12">  
    <%= form_for (@photo)  do|f| %>
      <div class="row album_wall">
        <% if notice && notice != "Signed in successfully." %><div class="alert alert-info"><%= notice %></div><% end %>
        <% if alert %><div class="alert alert-danger"><%= alert %></div><% end %>
        <div class="row col-lg-12">
          <div class="col-lg-6">
            <div class="form-group">
              <%= f.label :title %>
              <%= f.text_field :title, class: 'form-control', require: true, autofocus: true %>
            </div>
          </div>
          <div class="col-lg-6">
            <div class="form-group">
              <%= f.label :description %>
              <%= f.text_field :description, class: 'form-control', require: true  %>
            </div>
          </div>
        </div>
        <div class="row col-lg-12">
          <div class="form-group col-lg-6 ">
            <%= f.label "Sharing mode" %>
            <%= f.select(:private, options_for_select([['Public', false], ['Private', true]] ), {}, {:class => 'form-control'})  %>
          </div>
        </div>
        <div class=" form-group col-lg-4 ">
          <div id="image-upload" >
            <i class="fa fa-window-close fa-2x close-icon" aria-hidden="true" id = "close-new-icon"></i>
            <label for="file-input-photo" class="label-upload" id= "new-image">
                <img src="#" class="photo medium" id="output-new-photo">
            </label>
            <label for="file-input-photo" class="label-upload" id = "upload-new-photo"  >
                <i class="fa fa-plus" style="font-size:70px; color: #BDBDBD;" id = "plus-icon"></i>
            </label>
            <%= f.file_field :image, multiple: false, id: "file-input-photo", onchange: "document.getElementById('output-new-photo').src = window.URL.createObjectURL(this.files[0])", class: "form-group upload-img"%><br> 
            <%= f.submit 'Upload', class: 'btn btn-success btn-lg search' %>
          </div>
        </div>
      </div> 
    <% end %>
  </div>
</div>